import { RemoteImage } from "./load-image.js";
import { ModelType, TextureCanvas, TextureSource } from "./types.js";
export declare function applyMixins(derivedCtor: any, baseCtors: any[]): void;
export declare function isTextureSource(value: TextureSource | RemoteImage): value is TextureSource;
export declare abstract class SkinContainer<T> {
    protected abstract skinLoaded(model: ModelType, options?: T): void;
    protected abstract get skinCanvas(): TextureCanvas;
    protected abstract resetSkin(): void;
    loadSkin(empty: null): void;
    loadSkin<S extends TextureSource | RemoteImage>(source: S, model?: ModelType | "auto-detect", options?: T): S extends TextureSource ? void : Promise<void>;
}
export declare abstract class CapeContainer<T> {
    protected abstract capeLoaded(options?: T): void;
    protected abstract get capeCanvas(): TextureCanvas;
    protected abstract resetCape(): void;
    loadCape(empty: null): void;
    loadCape<S extends TextureSource | RemoteImage>(source: S, options?: T): S extends TextureSource ? void : Promise<void>;
}
